/******************************************************************************
 * (c) 2018 Microchip Technology Inc.Ǝq
 *
 * ̏̏ƂāAMicrochipĳƉ̔hMicrochipi
 * ɌĎgp邱Ƃł܂BMicrochipĳ𔺂Ȃ(J 
 * ĳ܂)Oҿĳ̎gpɓKpO҂̋炷̂͂
 * ̐ӔCłB
 *
 * ̿ĳMicrochip"󂻂̂܂"ɂċ܂BNQAiA
 * ړIւ̓K̂ǂ̈Öق̕ۏ؂܂߁AIAÎI܂͖@߂ł낤
 * ̿ĳɂ͓Kp܂BႦMicrochip\iꂽAQ\
 * ƂĂA̔@Ɋւ炸A@ȂꍇłMicrochipͿĳɊ֘A
 * @Ȃނ̊ԐړIAʁAIAI܂͕KRIȑAQAp
 * ͎x̐ӔC𕉂܂B@ɂċő͈̔͂܂ŁA̿ĳ
 * Ɋ֘Aǂ̕@ł̑SɉĂAmicrochip̑ӔCźA΁A
 * Ȃ̿ĳɑ΂Microchip֒ڎxp̊z𒴂܂B
 *
 *****************************************************************************/

/*
 * tinyAVR 01nymegaAVR 0npUARTް۰
 * 󂯎e޲Ă͎MmF̂ߑԂ܂B
 *
 * ݽ׸̈ɒuׂް۰ނɂĂToolchain->AVR/GNU Linker->General
 * ŕWņق֎~邱ƂKvłB
 *
 * ̗͈ȉݔzuATtiny817pɏĂ܂B
 * USART0 TxD PB2
 * USART0 RxD PB3
 * LED0       PB4
 * SW1        PC5 (Oٱ)
 */
#define F_CPU_RESET (20E6/6)

#include <avr/io.h>
#include <assert.h>
#include <stdbool.h>

/* ްڰč\ݒ */
#define BOOT_BAUD (115200)

/* ؍\ݒ
 * BOOTEND_FUSE~256ް۰ ۸ ؎gpʈȏłȂ΂Ȃ܂B
 * ͍œK-O3194޲ĂŁÂBOOTEND_FUSE = 0x01łB
 */
#define BOOTEND_FUSE               (0x01)
#define BOOT_SIZE                  (BOOTEND_FUSE * 0x100)
#define MAPPED_APPLICATION_START   (MAPPED_PROGMEM_START + BOOT_SIZE)
#define MAPPED_APPLICATION_SIZE    (MAPPED_PROGMEM_SIZE - BOOT_SIZE)

/* ˭ލ\ݒ
 * BOOTEND256޲Ẳްė̈̑傫(Ō+1)ݒ肵܂B
 * APPEND = 0x00͉pނƂBOOTEND~256ׯ̍Ō܂ł`܂B
 * c˭ނ͊`Ԑݒ܂B
 */
FUSES = {
	.OSCCFG = FREQSEL_20MHZ_gc,
	.SYSCFG0 = CRCSRC_NOCRC_gc | RSTPINCFG_UPDI_gc,
	.SYSCFG1 = SUT_64MS_gc,
	.APPEND = 0x00,
	.BOOTEND = BOOTEND_FUSE
};

/* p߲^` */
typedef void (*const app_t)(void);

/* ̪֐^ */
static bool is_bootloader_requested(void);
static void init_uart(void);
static uint8_t uart_receive(void);
static void uart_send(uint8_t byte);
static void init_status_led(void);
static void toggle_status_led(void);

/*
 * ްĊ֐
 * ׯߖ񂷂邽߂ɺݽ׸̈(.ctors)ɒuĂB
 * ֐۰ނƴ۰ނsgp̂ߗ̑gp܂B
 */
__attribute__((naked)) __attribute__((section(".ctors"))) void boot(void)
{
	/* AVR GCCxAR1=0Ӑ}悤ɼт */
	asm volatile("clr r1");

	/* pڍsA܂ް۰ތp𒲍 */
	if(!is_bootloader_requested()) {
		/* ްė̈{ */
		NVMCTRL.CTRLB = NVMCTRL_BOOTLOCK_bm;

		/* ްė̈撼ɔzu鉞p֍sB */
		app_t app = (app_t)(BOOT_SIZE / sizeof(app_t));
		app();
	}

	/* ʐM̪ */
	init_uart();
	init_status_led();

	/*
	 * p̈̐擪۸ݸ()Jn
	 * 傫ׯeʂł̈邽߂̏MAPPED_PROGMEM_STARTZ
	 */
	uint8_t *app_ptr = (uint8_t *)MAPPED_APPLICATION_START;
	while(app_ptr - MAPPED_PROGMEM_START <= (uint8_t *)PROGMEM_END) {
		/* M؂ɐݒ肷Oް𑗂Ԃ */
		uint8_t rx_data = uart_receive();
		uart_send(rx_data);

		/* ׯɏOɈʒuI߰ފɏՕ֐ݒ */
		*app_ptr = rx_data;
		app_ptr++;
		if(!((uint16_t)app_ptr % MAPPED_PROGMEM_PAGE_SIZE)) {
			/* ߰ދEBA߰ނׯɈn() */
			_PROTECTED_WRITE_SPM(NVMCTRL.CTRLA, NVMCTRL_CMD_PAGEERASEWRITE_gc);
			while(NVMCTRL.STATUS & NVMCTRL_FBUSY_bm);

			toggle_status_led();
		}
	}

	/*  ؾĔs */
	_PROTECTED_WRITE(RSTCTRL.SWRR, RSTCTRL_SWRE_bm);
}

/*
 * ް v֐
 */
static bool is_bootloader_requested(void)
{
	/* SW1 (PC5)Low */
	if(VPORTC.IN & PIN5_bm) {
		return false;
	}
	return true;
}

/*
 * ʐM̪֐
 */
static void init_uart(void)
{
	/* UART\ݒ */
	USART0.CTRLB = USART_RXEN_bm | USART_TXEN_bm;

	/* ްĂ:
	 * HŊi[ꂽg덷ŕ⏞ꂽްڰ
	 * ްڰ(̈)Ȃ񓯊ʐM
	 * 20MHzۯA3V
	 */
	int32_t baud_reg_val  = (F_CPU_RESET * 64) / (BOOT_BAUD * 16);	// zBAUDڼ޽l
	assert(baud_reg_val >= 0x4A);			// ̍őrŐȍŏBAUDڼ޽lmF
	int8_t sigrow_val = SIGROW.OSC20ERR3V;	// t덷ǂ
	baud_reg_val *= (1024 + sigrow_val);	// (\+덷)ŏZ
	baud_reg_val += 512;					// ۂߌ덷p⏞
	baud_reg_val /= 1024;					// \ŏZ
	USART0.BAUD = (int16_t) baud_reg_val;	// ␳ްڰĐݒ

	/* TxD(PB2)o͂ƂĐݒ */
	VPORTB.DIR |= PIN2_bm;
}

static uint8_t uart_receive(void)
{
	/* Mް ߰ݸ */
	while(!(USART0.STATUS & USART_RXCIF_bm));
	return USART0.RXDATAL;
}

static void uart_send(uint8_t byte)
{
	/* TXDATAꂽް܂B */
	USART0.TXDATAL = byte;
}

static void init_status_led(void)
{
	/* LED0(PB4)o͂ƂĐݒ */
	VPORTB.DIR |= PIN4_bm;
}

static void toggle_status_led(void)
{
	/* LED0(PB4)ݐ؂ւ */
	VPORTB.OUT ^= PIN4_bm;
}
